// BEGIN CUT HERE

// END CUT HERE

#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <utility>
#include <algorithm>
#include <list>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <memory>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cctype>
#include <cstring>
#include <climits>

#define foreach(it, c) for(typeof((c).begin()) it = (c).begin(); it != (c).end(); it++)
#define forx(i, start, end, step) for(size_t i = (start); i != (end); i += (step))
#define fori(i, start, end) for(size_t i = (start); i != (end); i++)
#define forn(i, end) fori((i), 0, (end))
#define repeat(n) for(int i = 0; i < n; i++)

using namespace std;


class PowerOutage
{
public:
    int estimateTimeOut(vector <int> fromJunction, vector <int> toJunction, vector <int> ductLength)
    {
        map<int, map<int, int> >G;
        size_t num = 0;
        for (size_t i = 0; i < fromJunction.size(); i++)
        {
            if (num < toJunction[i])
            {
                num = toJunction[i];
            }
            G[fromJunction[i]][toJunction[i]] = ductLength[i];
            G[toJunction[i]][fromJunction[i]] = ductLength[i];
        }
        vector<int> visited;
        repeat(num)
        visited.push_back(false);

        floyd(G, num + 1);
        return dfs(G, visited, 0).first;
    }

private:
    vector<vector<int> > D;

    vector<vector<int> > floyd(map<int, map<int, int> >G, int n)
    {
        repeat(n)
        {
            D.push_back(vector<int>(n));
        }
        forn(i, n)
        forn(j, n)
        D[i][j] = G[i][j];

        forn(k, n)
        forn(i, n)
        forn(j, n)
        {
            if (i !=j && D[i][k] && D[k][j])
            {
                if (D[i][j])
                    D[i][j] = min(D[i][j], D[i][k] + D[k][j]);
                else
                    D[i][j] = D[i][k] + D[k][j];
            }
        }
        return D;
    }



    pair<int, int> dfs(map<int, map<int, int> > &G, vector<int> &visited, int start)
    {
//        clog << "start: " << start << ",\tvistied[5]: " << visited[5] << endl;

        int rlen = INT_MAX, rstop = start;
        visited[start] = 1;

        map<int, map<int, int> > G2 = G;
        G2.erase(start);
        foreach(i, G2)
        foreach(j, i->second)
        {
            if (j->first == start)
                i->second.erase(j);
        }

        vector<int> rv = visited;
        map<int, map<int, int> > rG = G2;
        bool enter = false;

        foreach(it, G[start])
        {
            if (!visited[it->first])
            {
                int len = 0, stop = start;
                vector<int> v2(visited.size()) ;
                clog << "outter0:\tv2.size(): " << v2.size() << ", visited.size(): " << visited.size()
                    << "\tv2[5]: " << v2[5] << ",\tvistied[5]: " << visited[5] << endl;
                copy(visited.begin(), visited.end(), v2.begin());
//                forn(i, visited.size())
//                    v2.push_back(visited[i]);
                clog << "outter1:\tv2.size(): " << v2.size() << ", visited.size(): " << visited.size()
                    << "\tv2[5]: " << v2[5] << ",\tvistied[5]: " << visited[5] << endl;
                map<int, map<int, int> > G3 = G2;
                foreach(jt, G[start])
                {
                    if (!visited[jt->first])
                    {
                        enter = true;
                        pair<int, int> l = dfs(G3, v2, jt->first);
//                        clog << "inner:\tv2[5]: " << v2[5] << ",\tvistied[5]: " << visited[5] << endl;
                        len += jt->second + l.first + D[l.second][start];
                        if (D[stop][start] < D[l.second][start])
                        {
                            stop = l.second;
                        }
                    }
                }
                len -= D[stop][start];
                if (len < rlen)
                {
                    rlen = len;
                    rv = v2;
                    rG = G3;
                    rstop = stop;
                }
            }
        }

        G = rG;
        visited = rv;
        rlen = enter ? rlen : 0;
        return make_pair(rlen, rstop);
    }

// BEGIN CUT HERE
public:
    void run_test(int Case)
    {
        if ((Case == -1) || (Case == 0)) test_case_0();
        if ((Case == -1) || (Case == 1)) test_case_1();
        if ((Case == -1) || (Case == 2)) test_case_2();
        if ((Case == -1) || (Case == 3)) test_case_3();
        if ((Case == -1) || (Case == 4)) test_case_4();
    }
private:
    template <typename T> string print_array(const vector<T> &V)
    {
        ostringstream os;
        os << "{ ";
        for (typename vector<T>::const_iterator iter = V.begin(); iter != V.end(); ++iter) os << '\"' << *iter << "\",";
        os << " }";
        return os.str();
    }
    void verify_case(int Case, const int &Expected, const int &Received)
    {
        cerr << "Test Case #" << Case << "...";
        if (Expected == Received) cerr << "PASSED" << endl;
        else
        {
            cerr << "FAILED" << endl;
            cerr << "\tExpected: \"" << Expected << '\"' << endl;
            cerr << "\tReceived: \"" << Received << '\"' << endl;
        }
    }
    void test_case_0()
    {
        int Arr0[] = {0};
        vector <int> Arg0(Arr0, Arr0 + (sizeof(Arr0) / sizeof(Arr0[0])));
        int Arr1[] = {1};
        vector <int> Arg1(Arr1, Arr1 + (sizeof(Arr1) / sizeof(Arr1[0])));
        int Arr2[] = {10};
        vector <int> Arg2(Arr2, Arr2 + (sizeof(Arr2) / sizeof(Arr2[0])));
        int Arg3 = 10;
        verify_case(0, Arg3, estimateTimeOut(Arg0, Arg1, Arg2));
    }
    void test_case_1()
    {
        int Arr0[] = {0,1,0};
        vector <int> Arg0(Arr0, Arr0 + (sizeof(Arr0) / sizeof(Arr0[0])));
        int Arr1[] = {1,2,3};
        vector <int> Arg1(Arr1, Arr1 + (sizeof(Arr1) / sizeof(Arr1[0])));
        int Arr2[] = {10,10,10};
        vector <int> Arg2(Arr2, Arr2 + (sizeof(Arr2) / sizeof(Arr2[0])));
        int Arg3 = 40;
        verify_case(1, Arg3, estimateTimeOut(Arg0, Arg1, Arg2));
    }
    void test_case_2()
    {
        int Arr0[] = {0,0,0,1,4};
        vector <int> Arg0(Arr0, Arr0 + (sizeof(Arr0) / sizeof(Arr0[0])));
        int Arr1[] = {1,3,4,2,5};
        vector <int> Arg1(Arr1, Arr1 + (sizeof(Arr1) / sizeof(Arr1[0])));
        int Arr2[] = {10,10,100,10,5};
        vector <int> Arg2(Arr2, Arr2 + (sizeof(Arr2) / sizeof(Arr2[0])));
        int Arg3 = 165;
        verify_case(2, Arg3, estimateTimeOut(Arg0, Arg1, Arg2));
    }
    void test_case_3()
    {
        int Arr0[] = {0,0,0,1,4,4,6,7,7,7,20};
        vector <int> Arg0(Arr0, Arr0 + (sizeof(Arr0) / sizeof(Arr0[0])));
        int Arr1[] = {1,3,4,2,5,6,7,20,9,10,31};
        vector <int> Arg1(Arr1, Arr1 + (sizeof(Arr1) / sizeof(Arr1[0])));
        int Arr2[] = {10,10,100,10,5,1,1,100,1,1,5};
        vector <int> Arg2(Arr2, Arr2 + (sizeof(Arr2) / sizeof(Arr2[0])));
        int Arg3 = 281;
        verify_case(3, Arg3, estimateTimeOut(Arg0, Arg1, Arg2));
    }
    void test_case_4()
    {
        int Arr0[] = {0,0,0,0,0};
        vector <int> Arg0(Arr0, Arr0 + (sizeof(Arr0) / sizeof(Arr0[0])));
        int Arr1[] = {1,2,3,4,5};
        vector <int> Arg1(Arr1, Arr1 + (sizeof(Arr1) / sizeof(Arr1[0])));
        int Arr2[] = {100,200,300,400,500};
        vector <int> Arg2(Arr2, Arr2 + (sizeof(Arr2) / sizeof(Arr2[0])));
        int Arg3 = 2500;
        verify_case(4, Arg3, estimateTimeOut(Arg0, Arg1, Arg2));
    }

// END CUT HERE

};

// BEGIN CUT HERE
int main()
{
    PowerOutage ___test;
    ___test.run_test(2);
}
// END CUT HERE
